apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups and (do_s3 or (not do_s3 and not codimd_imgur_client_id)) %}
{% if do_s3 %}
    backups.opsperator.io/driver: s3
{% else %}
    backups.opsperator.io/driver: ssh
{% endif %}
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
{% if not do_s3 %}
    backups.opsperator.io/secret: backups-{{ codimd_name }}
    backups.opsperator.io/service: backups-{{ codimd_name }}
{% elif codimd_s3_flavor == 'minio' %}
    backups.opsperator.io/secret: {{ minio_name }}-codimd
    backups.opsperator.io/service: {{ minio_name }}-client
{% elif codimd_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
    backups.opsperator.io/secret: {{ rgw_name }}-codimd
    backups.opsperator.io/service: {{ rgw_name }}
{% endif %}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ codimd_name }}
  name: {{ codimd_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ codimd_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ codimd_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ codimd_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ codimd_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ codimd_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ codimd_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
{% if (airbrake_id | default(False)) and (airbrake_key | default(False)) %}
        - name: AIRBRAKE_ID
          valueFrom:
            secretKeyRef:
              key: airbrake-id
              name: {{ codimd_name }}-airbrake
        - name: AIRBRAKE_KEY
          valueFrom:
            secretKeyRef:
              key: airbrake-key
              name: {{ codimd_name }}-airbrake
{% if airbrake_host | default(False) %}
        - name: AIRBRAKE_HOST
          valueFrom:
            secretKeyRef:
              key: airbrake-host
              name: {{ codimd_name }}-airbrake
{% endif %}
{% else %}
        - name: AIRBRAKE_ID
          value: ""
        - name: AIRBRAKE_KEY
          value: ""
{% endif %}
        - name: CMD_IMAGE_UPLOAD_TYPE
          value: filesystem
        - name: CODIMD_DB_DRIVER
{% if codimd_db_type in [ 'mariadb', 'mysql', 'percona' ] %}
          value: mysql
{% else %}
          value: postgres
{% endif %}
        - name: CODIMD_DOMAIN
          value: {{ codimd_fqdn }}
        - name: CODIMD_ORG_NAME
          value: {{ codimd_org_name }}
        - name: CODIMD_IMGUR_CLIENT_ID
{% if not do_s3 and codimd_imgur_client_id %}
          value: {{ codimd_imgur_client_id }}
{% else %}
          value: ""
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: FORKS
          value: "1"
        - name: LLNG_PROTO
{% if do_lemon %}
          value: {{ lemon_portal | urlsplit('scheme') }}
        - name: LLNG_SSO_DOMAIN
          value: {{ lemon_portal | urlsplit('hostname') }}
{% else %}
          value: ""
        - name: LLNG_SSO_DOMAIN
          value: ""
{% endif %}
{% if codimd_db_type == 'percona' %}
        - name: MYSQL_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ cdmdpc_name }}
        - name: MYSQL_HOST
          value: {{ cdmdpc_name }}
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ cdmdpc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ cdmdpc_name }}
{% elif codimd_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ cdmdms_name }}
        - name: MYSQL_HOST
          value: {{ cdmdms_name }}
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ cdmdms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ cdmdms_name }}
{% endif %}
        - name: NO_K8S_ENV
          value: pm2-is-stupid
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: "{% if (ldaps_address | default(False) and skip_ldap_verify | default(False)) or (do_lemon and skip_lemon_verify | default(False)) %}0{% endif %}"
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=codimd,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: codimd-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ codimd_ldap_user_objectclass }}
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USERS_OBJECTCLASS
          value: ""
{% endif %}
{% if codimd_db_type == 'postgres' %}
        - name: POSTGRES_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ cdmdpg_name }}
        - name: POSTGRES_HOST
          value: {{ cdmdpg_name }}
        - name: POSTGRES_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ cdmdpg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ cdmdpg_name }}
{% endif %}
{% if do_s3 %}
{% if codimd_s3_flavor == 'minio' %}
        - name: S3_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name }}-codimd
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name }}-codimd
        - name: S3_HOST
          value: {{ minio_api_address | urlsplit('hostname') }}
        - name: S3_IS_MINIO
          value: yay
        - name: S3_PORT
          value: "{{ minio_api_address | urlsplit('port') }}"
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name }}-codimd
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name }}-codimd
{% elif codimd_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
        - name: S3_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name }}-codimd
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name }}-codimd
        - name: S3_HOST
          value: {{ radosgw_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ radosgw_api_address | urlsplit('port') }}"
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name }}-codimd
{% endif %}
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='codimd'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='codimd'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 3000
          timeoutSeconds: 3
        name: codimd
        ports:
        - containerPort: 3000
        readinessProbe:
          failureThreshold: 5
          httpGet:
            path: /css/center.css
            port: 3000
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ codimd_cpu_limit }}"
            memory: "{{ codimd_memory_limit }}"
          requests:
            cpu: "{{ codimd_cpu_request }}"
            memory: "{{ codimd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (do_ldap or do_lemon or airbrake_host | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /opt/app-root/src/saml
          name: data
          subPath: saml
        - mountPath: /opt/app-root/src/public/uploads
          name: data
          subPath: upload
{% if do_backups and not do_s3 and not codimd_imgur_client_id %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
          subPath: upload
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ codimd_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if do_s3 or codimd_imgur_client_id %}
      - emptyDir: {}
        name: data
{% else %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ codimd_name }}
{% endif %}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or airbrake_host | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if airbrake_host | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: airbrake-ca.crt
{% if errbit_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if not do_s3 and not codimd_imgur_client_id and do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ codimd_name }}
      - emptyDir: {}
        name: tmp
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='codimd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - codimd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='codimd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and not do_s3 and not codimd_imgur_client_id and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
